import { RendererEvent } from '../utils/renderer-event';
import { RendererAction, ListenerAction, ListenerContext } from './Action';
export interface ILinkAction extends ListenerAction {
    link: string;
    url?: never;
    blank?: boolean;
    params?: {
        [key: string]: string;
    };
}
export interface IUrlAction extends ListenerAction {
    url: string;
    link?: never;
    blank?: boolean;
    params?: {
        [key: string]: string;
    };
}
/**
 * 打开页面动作
 *
 * @export
 * @class LinkAction
 * @implements {Action}
 */
export declare class LinkAction implements RendererAction {
    run(action: ILinkAction | IUrlAction, renderer: ListenerContext, event: RendererEvent<any>): Promise<void>;
}
